# frozen_string_literal: true

module Ephemeron
  class Store
    module AllowFetch
      module_function

      def call(model)
        last_events = Ephemeron::Logger::Finders
                      .find_all_events_for(model, :fetch_allowed, :fetched)
                      .last(2)
        cond1 = last_events[0] == Logger::Convert.call(model, :fetch_allowed)
        cond2 = last_events[1] == Logger::Convert.call(model, :fetched)
        cond1 && cond2
      end
    end
  end
end
