# frozen_string_literal: true

module Ephemeron
  class Store
    class Convert
      class << self
        def call(model_s, as_new_record: false)
          if model_s.is_a?(ActiveRecord::Base)
            return class_name_and_id(model_s, as_new_record: as_new_record)
          end

          model_s.map { |model| class_name_and_id(model) }.join ', '
        end

        private

        def class_name_and_id(model, as_new_record: false)
          new_record = as_new_record || model.new_record?
          name = model.class.name.downcase
          id = new_record ? "new_record##{model.object_id}" : model.id
          "#{name}##{id}"
        end
      end
    end
  end
end
