# frozen_string_literal: true

module Ephemeron
  class Store
    module Finders
      module_function

      def find_first_allowed_but_unsaved
        ary = Logger.logs
                    .reverse
                    .map { |line| line.split ' ' }
                    .find { |arr| %w[save_allowed saved].include?(arr[1]) }
        return nil if ary.nil? || ary[1] == 'saved'

        Store.store[ary[0]]
      end
    end
  end
end
