# frozen_string_literal: true

module Ephemeron
  class Store
    module Update
      module_function

      def call(model)
        return unless Store.has? model, as_new_record: true

        Store.add model
        Store.store.delete Convert.call(model, as_new_record: true)

        Store.aliases.find_all { |_, v| v == Convert.call(model, as_new_record: true) }
             .to_h
             .each_key { |key| Store.aliases[key] = Convert.call(model) }
      end
    end
  end
end
