# frozen_string_literal: true

module Ephemeron
  module Validators
    module Store
      module AllowedButUnsaved
        module_function

        def call
          model = Ephemeron::Store::Finders.find_first_allowed_but_unsaved
          return if model.nil?

          raise(
            PersistenceError,
            "save allowed for #{Ephemeron::Store::Convert.call(model)} but never saved"
          )
        end
      end
    end
  end
end
