# frozen_string_literal: true

module Ephemeron
  module Validators
    module Store
      module Unused
        module_function

        def call
          models = Ephemeron::Store
                   .store
                   .filter { |_, model| !model.changed? && !Logger.has?(model, :used) }
                   .values
          return if models.empty?

          model_ids = Ephemeron::Store::Convert.call(models)
          raise(
            StoreError,
            "#{model_ids} were added to store but neither fetched nor changed"
          )
        end
      end
    end
  end
end
