# frozen_string_literal: true

module Ephemeron
  class Callbacks < ThreadStore
    attribute :ts_after_save_callbacks

    def after_save_callbacks
      self.ts_after_save_callbacks ||= []
    end

    def add(callback)
      after_save_callbacks << callback
    end

    def call
      after_save_callbacks.each(&:call)
    end

    def reset
      self.ts_after_save_callbacks = []
    end
  end
end
